#!/usr/bin/python
# -*- encoding: utf-8 -*-

'''wmtrashpy.py

WindowMaker dockapp for trash.

Copyright (C) 2012 Konstantin Kogan.

Licensed under the GNU General Public License.

'''

import sys
import time
import getopt
import os
import os.path
import Tkinter as tk
from Tkinter import *
#import tkFileDialog
from tkFileDialog import askopenfilename
import pywmhelpers
import glob

global par
width = 64
height = 64

lettersStartX = 0
lettersStartY = 74
letterWidth = 6
letterHeight = 8

digitsStartX = 0
digitsStartY = 64
digitWidth = 6
digitHeight = 8

xOffset = 4
yOffset = 4

letters = 'abcdefghijklmnopqrstuvwxyz'
digits = '0123456789:/- '

flg = 1
xs = 57
ys = 57
n = 2

defaultRGBFiles = ['/usr/lib/X11/rgb.txt', '/usr/X11R6/lib/X11/rgb.txt']
maxCharsPerLine = 9

def trash_remove(event):
    global root
    global flg
    flg = 1
    root.withdraw()
    
    for (p, d, f) in os.walk(os.path.expanduser('~/.local/share/Trash/files'), False):
	for file_name in f: # удаляем файлы из корзины
	    os.remove(os.path.join(p, file_name))
	for dir_name in d: # удаляем каталоги из корзины
	    os.rmdir(os.path.join(p, dir_name)) 
    for (p, d, f) in os.walk(os.path.expanduser('~/.local/share/Trash/info'), False):
	for file_name in f: # удаляем файлы пути восстановления
	    os.remove(os.path.join(p, file_name))	    
    f = open (os.path.expanduser('~/.local/share/Trash/metadata'), "w")
    f.write("[Cached]\nSize=0\n")
    f.close()
    
def trash_look(event): 
        i = 1
	global root
	root.withdraw()
	home = (os.path.expanduser('~'))
	home = home + '/.wmtrashpy'
	print (home)
	try:
	    f = open (home , 'r')
	except IOError:
	    print ('нет файла') 
	    parametr('нет файла')
	finally:    
	    print('look')
	    #f.close()
	    f = open (home , 'r')
	    manager = f.read()
	    print ('this is ')
	    print (manager)
	    if manager == 'only_view':
	        op = askopenfilename(initialdir="~/.local/share/Trash/files")
	    else:
	        managerput = os.path.join("/usr/bin/",manager)
	        print type(managerput)
	        print (managerput)
	        m = str(managerput)
	    #if os.path.exist(m):
	        if manager == 'spacefm':
		  manager = manager + " '~/.local/share/Trash/files'"
		else:  
		  manager = manager + " trash:/"
	        print (manager)
	        os.system(manager)
	    #else:	op = askopenfilename(initialdir="~/.local/share/Trash/files")
	    root.deiconify()

	
def Get(event):
    global destr
    global par
    global flg
    lis = event.widget
    sel = lis.curselection()
    if len(sel) == 1:
        s = lis.get(sel[0])
        if s[0] == '-':
            lis.selection_clear(sel[0])
        else:
            print s
            home = (os.path.expanduser('~'))
	    home = home + '/.wmtrashpy'
	    f = open (home , 'w')
	    f.write(s)
	    f.close()
	    destr = 1
	    flg = 0
	    print ('exit')
	    par.destroy()
	    return
	
def parametr(event):
	global destr
	global par
	global root
	global flg
	global x
	global y
	flg = 1
	root.withdraw()
	destr = 0
	par = Tk()
	par.geometry('+'+str(x)+'+'+str(y))
	par.overrideredirect(True)
	#par.borderwidth =  5
	lab = Label(par,width=30,height=1,
               font="Verdana 14" ,bg='#000000',fg='#ffffff',text='Выберите файловый менеджер')
               
	lab.pack()
	r=[]
	if 	 os.path.exists(r"/usr/bin/thunar"):
		      r.append('thunar')
	if 	 os.path.exists(r"/usr/bin/pcmanfm"):
		      r.append('pcmanfm')
	if  	 os.path.exists(r"/usr/bin/dolphin"):
		      r.append('dolphin')
	if   	 os.path.exists(r"/usr/bin/konqueror"):
		      r.append('konqueror')
	if   	 os.path.exists(r"/usr/bin/spacefm"):
		      r.append('spacefm')		      
	if   	 os.path.exists(r"/usr/bin/krusader"):
		      r.append('krusader')
        if       os.path.exists(r"/usr/bin/xterm"):
                      r.append('only_view')
        #r = ['thunar','pcmanfm','dolphin','konqueror','krusader','only_view']
	
	
	
	lis = Listbox(par,width=30, height = len(r),bg='#c2cad2',font="Verdana 14")
	for i in r:
	  lis.insert(END,i)  
	lis.pack()
	lis.bind("<<ListboxSelect>>", Get)
	home = (os.path.expanduser('~'))
	home = home + '/.wmtrashpy'
	print (home)
	
	print(destr)

	    
	
def spravka(event):
        global n
	global text
	global spr
        m = n%2
	#spr = Tk()
	if m == 0 :
	    spr = Tk()
	    spr.overrideredirect(True)
	    text = Text(spr,width=59,height=11,
               font="Verdana 10",
	       wrap=WORD)
	    text.pack () 
	    text.insert(1.0,
	'\n       wmtrashpy - апплет Window Maker для работы с корзиной . Вы можете просто очистить корзину не заглядывая в нее. Если в вашей системе установлен какой-либо из этих файловых менеджеров:  \n\
	 thunar , pcmanfm, dolphin, konqueror, spacefm или krusader ,то по кнопке открыть корзину она откроется в менеджере файлов ( менеджер по умолчанию выбирается кнопкой Настройки )  . \n\
	Внимание, для закрытия этого окна нажмите еще раз на кнопку Справка , а для закрытия основного окна нажмите на иконку апплета (корзину)  ! \n\n')  

	    
        else :
	    ud(event)
	n= n+1

def ud(event):
        text.pack_forget()
	spr.destroy()



def checkForEvents():
        global flg
        
        event = pywmhelpers.getEvent()
        while not event is None:
            if event['type'] == 'buttonrelease':
                
				if flg == 1:				
				   flg = 0
				else:
				   flg = 1

            elif event['type'] == 'destroynotify':
                sys.exit(0)
            event = pywmhelpers.getEvent()

def trash(): # Отображение значка пустой корзины
	pywmhelpers.copyXPMArea(121,3,42,62,15,3)
	#print '1'
	
def trashfool(): # Отображение значка полной корзины	
	pywmhelpers.copyXPMArea(64,4,49,62,3,5)
	#print '2'

def mainLoop(): # Основной цикл программы
    global root
    global x
    global y
    root = Tk()
    root.title("wmtrashpy")
    root.minsize(width=3*xs+38,height=208)
    root.maxsize(width=3*xs+38,height=208)
    x = root.winfo_screenwidth()/2
    y = root.winfo_screenheight()/2
    x = x - 100
    y= y-75
    s = '200x208+'+str(x)+'+'+str(y)
    root.attributes("-zoomed")
    root.geometry(s)
    root.transient()
    root.protocol("WM_DELETE_WINDOW", 0 ) # запрет закрытия окна
    
    button1 = Button(root,width=202,height=50)
    img1 = PhotoImage(file = 'Data/trash_erase.gif')
    button1["image"] = img1
    button1.place(x='1',y='1')
    button1.bind("<Button-1>", trash_remove )
    #button1.pack()
    
    button2 = Button(root,width=202,height=50)
    img2 = PhotoImage(file = 'Data/trash_view.gif')
    button2["image"] = img2
    button2.place(x='1',y='51')   
    button2.bind("<Button-1>",
    trash_look )
    #button2.pack()

    button3 = Button(root,width=202,height=50)
    img3 = PhotoImage(file = 'Data/trash_parametr.gif')
    button3["image"] = img3
    button3.place(x='1',y='101')   
    button3.bind("<Button-1>",parametr)
    #button3.pack()
    
    button4 = Button(root,width=202,height=50)
    img4 = PhotoImage(file = 'Data/trash_help.gif')
    button4["image"] = img4
    button4.place(x='1',y='151')   
    button4.bind("<Button-1>",spravka)

    root.lift()
    root.bind('<Escape>',exit)
    root.overrideredirect(1) #убивает рамку окна
    pausa = 0
    while 1:
        pywmhelpers.redraw()
        pausa = pausa+1
        if pausa == 10: # проверяет количество файлов в корзине  один раз в 2 секунды
	    try:
		number = len(os.listdir(os.path.expanduser('~/.local/share/Trash/files') ))
	    except: # Если корзина еще не была создана
		os.mkdir(os.path.expanduser('~/.local/share/Trash'))
		os.mkdir(os.path.expanduser('~/.local/share/Trash/files'))
		os.mkdir(os.path.expanduser('~/.local/share/Trash/info'))
		f = open (os.path.expanduser('~/.local/share/Trash/metadata'), "w")
		f.write("[Cached]\nSize=0\n")
		f.close()
		number = 0
	    if number == 0:
		trash()
	    else:    
		trashfool()
            pausa = 0
	if flg ==1:
		root.withdraw()
	else:
		root.deiconify()
	root.update()
	checkForEvents()
	
	time.sleep(0.2)
	
        #trashfool()
	#pywmhelpers.copyXPMArea(62,0,0,0,0,0)
	
        
        
def main():
	
	pywmhelpers.setDefaultPixmap(xpm)
    	programName = ''
	sys.argv[0] = programName
	pywmhelpers.openXwindow(sys.argv, width, height)
	pywmhelpers.copyXPMArea(62,0,0,0,0,0)
   	mainLoop()

xpm = \
['160 100 18 1',
'  c #164816481648',
'. c #202020201F1F',
'X c #20492055205B',
'o c #70526D516958',
'O c #A3D657BE443D',
'+ c #E0E0B3B32E2E',
'@ c #164816481648',
'# c #2020B2B2AEA9',
'$ c #7F7F80808181',
'% c #AC6EAD4FAE42',
'& c #E3E3D5D5A4A4',
'* c #BDBDBFBFC19E',
'= c #BFBFC29CC62D',
'- c #D0E1D270D3E7',
'; c #EDEDE9E9DFDF',
': c #DCDCDEDEE0E0',
'> c #DEDEE1E1E3E3',
', c #EFFEF077F0FF',
'                                                                                                                                                                ',
'                                                                                                                                                               #',
'                                                                                                                                                               #',
'                                                                                                                                                               #',
'                                                                                                                                                                ',
'     @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@                                                                                                     ',
'     @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@                                                                                                     ',
'     @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@                                                                                                     ',
'     @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@                                      XXX                                                            ',
'     @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@                                     XOOO..                                                          ',
'     @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@                             XXXXXX$.OO+O&= .                                ooooo                   ',
'     @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@                        .o->,,$o==:O$= &++O $                        o$=%->,-->-:,-:,>$o$            ',
'     @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@                     $%%*=-,O  O-;o o +.=+OO :*o                  oo>--->::---=%-*--====:>-oo        ',
'     @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@                   o%**%  =o OO oo o +$X++*;O  ;-o              o==****-------*%=***====::-=,:$      ',
'     @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@                  -%$   oo  O++O  $*=o.O+%>o O ;;:-X           *$*%**%==---*-***%**===-=:>-=-=$*     ',
'     @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@                 %=$ OOo $ o++++ o**&.$+OO> o+O o%=&          %*$=-$*=%*---***==%*%=======%*$=o$=    ',
'     @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@                 >= oO+O O o$o   $&&$.++$  o+++o *=>          >*o$$$%=%=-=-***=%%**%%*%%*==$$ooo,    ',
'     @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@                 -:-%+++*$oOo oOo&&O.++O $o ===o==:>          --oo$-$=%==-=:=*%$%$%%===%-=$$oo$*:    ',
'     @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@                 %:;:=oo*oo$o +++ o$O+% o++o o-*->>>          *:-oooo==%%%-=$===%%$%$$=$$-oo*X->,    ',
'     @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@                 **-,;:-*--;,;>;,-.$++ -+*++o=:,,:>,          %=::%o$=oo==$$%$$$*===$-$$oooo=,>>>    ',
'     @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@                 %=-,,,,,,,---*>--$+o-%--->,,,,--->>          ==:>,,,-$-ooooo$ooooooooo=->,,--->>    ',
'     @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@                 ==-,,,,,,,,,,,,,,,,,;,;;,,,,,-==->>          %=-,,,,,,,,,>-=%*%%%%-:>,,,,,==---,    ',
'     @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@                 %=-,,,,,,,,;>--;,,;;>:----,>,==-->,X         %=:,,,,,,,,,,,>,,,,,,>:--:,,,==-->>    ',
'     @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@                 *=-;;,,,;,,;::=:,:;>:::---,,>==-->,          ==->,,,,,,,,,,:;,>>::--:--,,,===-:>    ',
'     @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@                 &->,,,,,,,,;:-->,,>>::->-->,>==---:          %=:>,,,,,,,,,,>>>,>>::-:-->,>=--->,    ',
'     @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@                 *=:,,,,,;,,,:-=,;:>>::----,>>==:-:>          *=-,,,,,,,,,,,>,,>>>:::---,>,==--:,    ',
'     @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@                 %=-;,,,>,,,,>-->,,>>>::---,>>=---:,          %=:,,,,,,,,,,,>>,>>>::---->>>==--->    ',
'     @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@                 %=-,,,,,,,,>>:->>>>>>::--=>>>==-->,          *=>,,,,,,,,,,,,>>,>>::-:--,>,==--:>    ',
'     @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@                 %=-;,,,,,,,,>--;,>>>>>---->>>==---:          %=-,,,,,,,,,,,:,>,,::::--->>>=---:,    ',
'     @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@                 ==-,,,,,,,,;;:->;,>::->--->>>=---:,          ==-,,,,,,,,,,,>>,>>:::---->>>==-->>    ',
'     @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@                 %=>,,,,>,,,,,>->,>>>::>--->>>==-->:          *=>>,,,,,,,,,,>>,>>>:->--->>>==-->>    ',
'     @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@                 ==:,,,,,,,,,,>-,,>>>::---->>>=----:          %=-,,,,,,,,,,,>,,>>>::->-->>>==---,    ',
'     @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@                 %=-,,,,,,,,,>::>,:,>::----;::==-->>X         *=:,,,,,,,,,,,>>,>>>::::-->:>=---:>    ',
'     @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@                 %=-,,,,>;,,,,:->,,>>:::---:::=---:,X         %*:,,,,,,,,,,,>>>,>>::----:::=---:>    ',
'     @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@                 *=-;,,,,,,,,,>::>>>>>:-:--:-:==---:          %*->,,,,,,,,,,>,,,>>:-::--:::==:-:>    ',
'     @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@                 %=:,,,,,,,,,,>-,,,>>>::--=::>=--->>          **-,,,,,,,,,,,>>>>>>::----::-==--:>    ',
'     @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@                 *=-;,,,>,,>,,,-:,>>:::---->->=---->          %=:>,,,,,,,,,>:>,>,,>::---:->=---->    ',
'     @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@                 %*->,,,,,,,,,,:,,>>::>>--->--==>->>          %*-,,,,,,,,,,>:,>,>>>:----:::=--:-,    ',
'     @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@                 %=->,,,,,,,,,,::,>>>::>---->-=----,          **-,,,,,,,,,,,:>,>>>:::---:--=----:    ',
'     @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@                 *%-,,,,,,,,,,,:,>>>>::----::-=-->>>          %*->,,,,,,,,,,>>,>>>:-:---:>-==-::>    ',
'     @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@                 *%-:,,,,,,,,,,::>,>>:::----:-=--:-:          *%->,,,,,,,,,,>>,>>>::-:--:->=->--,    ',
'     @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@                 *%=:,,,,,,,;,,:,,:>>::->---:-==--->          %=-,,,,,,,,,,,>,>>>>:::---->-==->:>    ',
'     @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@                 %%=>;,,,,,,:;::,;,>>::---->--=-::-,          %*->,,,,,,,,,,>>,:>>:::---:--=--:-:    ',
'     @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@                 %*--,;>,;,,;:--:,:>>:--------==:--:          %%=>,,,;,,,,>--,,>>>::-:------=:-->    ',
'     @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@                 =%=:,,,;,,,::-=--,>>::-------=-:--,          %%->,,,,,,,::-->,>>>::-------==::->    ',
'     @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@                 %%=-;:,;,,,::------,::->-----==::--          ***>,>>,,,,:>-*-:,,>:-:------=-:--:    ',
'     @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@                 %*=:>,>;,,;:,-=--===-::-----==-::=%          =**>,,,>,,,:--*--->::::------==::--    ',
'     @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@                 %%=-,;::,,;;--=--======--:--:==:=%=          %%=->>>,,,,:--**--*-:>;------==::=*    ',
'     @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@                 %%=-;>;>,,;:-----====%*%%**=%%%=*%=          =%-->,,>,,,>-**--*-***--:----=->=%=    ',
'     @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@                X$%=-::>>,;;:---==-====%%%%%$%%*=*=o          =%*-,>;>>,>::-*---****%%%*==*%*====    ',
'     @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@                  -=;;;:::>>:--=-===*=%%*%%%%%%%=--           -**:,:>>,,,:--*--*==***%*%*=%=%-*%o    ',
'     @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@                   $;::::;,;:-=-===**==%*%%*%*$*=o             **->>>>,>>:-==**-==%*%%%%*%==%===     ',
'     @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@                    X-,>;,,;---=-====*=*%%*%%%% X               o,,>::>,,---*-**=*****%**%*==-$      ',
'     @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@                       .*,,,,---=====%%%**=%=                    o*,:>>>>--*%*-*=**=%%%*%*=%=o       ',
'     @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@                          X -*--->:===%%  XX                       o$,,,,--=*==-***%%%%=%=oo         ',
'     @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@                                 XX                                   o=*:--%==-=*****ooo            ',
'     @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@                                                                           ooo$$oooo                 ',
'     @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@                                                                                                     ',
'     @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@                                                                                                     ',
'     @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@                                                                                                     ',
'                                                                                                                                                                ',
'                                                                                                                                                                ',
'                                                                                                                                                                ',
'                                                                                                                                                                ',
'                                                                                                                                                                ',
' #####   #   ##### ##### #   # ##### ##### ##### ##### #####          #          # #                                                                            ',
' #   #  ##       #     # #   # #     #         # #   # #   #  ##      #            #                                                                            ',
' #   #   #       #     # #   # #     #         # #   # #   #  ##     ##           ##                                                                            ',
' #   #   #   #####  #### ##### ##### #####     # ##### #####         #   #####    #                                                                             ',
' #   #   #   #         #     #     # #   #     # #   #     #        ##           ##                                                                             ',
' #   #   #   #         #     #     # #   #     # #   #     #  ##    #            #     ##                                                                       ',
' #####  ###  ##### #####     # ##### #####     # ##### #####  ##    #            # #   ##                                                                       ',
'                                                                                                                                                                ',
'                                                                                                                                                                ',
'                                                                                                                                                                ',
'  ###  ####   #### ####  ####  ##### ##### #   #   #       # #   # #     #   # ####  ##### ##### ##### ##### ##### ##### #   # #   # #   # #   # #   # #####    ',
' #   # #   # #     #   # #     #     #     #   #   #       # #   # #     ## ## #   # #   # #   # #   # #   # #       #   #   # #   # #   # #   # #   #     #    ',
' #   # #   # #     #   # #     #     #     #   #   #       # #  #  #     # # # #   # #   # #   # #   # #   # #       #   #   # #   # #   #  # #  #   #    #     ',
' ##### ####  #     #   # ####  ####  # ### #####   #       # ###   #     #   # #   # #   # ##### ##  # ####  #####   #   #   # #   # #   #   #   #####   #      ',
' #   # #   # #     #   # #     #     #   # #   #   #       # #  #  #     #   # #   # #   # #     # # # #   #     #   #   #   # #   # # # #  # #      #  #       ',
' #   # #   # #     #   # #     #     #   # #   #   #   #   # #   # #     #   # #   # #   # #     #  ## #   #     #   #   #   # #   # ## ## #   #     # #        ',
' #   # ####   #### ####  ####  #     ##### #   #   #    ###  #   # ####  #   # #   # ##### #     ##### #   # #####   #    ####  ###  #   # #   # ##### #####    ',
'                                                                                                                                                                ',
'@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@',
'@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@',
'@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@',
'@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@',
'@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@',
'@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@',
'@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@',
'@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@',
'@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@',
'@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@',
'@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@',
'@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@',
'@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@',
'@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@',
'@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@',
'@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@',
'@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@'
];






if __name__ == '__main__':
    main()

